From: Aron Xu <aron@debian.org>
Date: Sat, 9 Jun 2012 01:57:07 +0800
Subject: [PATCH] enable build platforms
Last-Update: 2018-08-06

---
 configure.in                |    2 +-
 src/console.cpp             |    2 +-
 src/console.h               |    3 ++-
 src/display/fbdev.h         |    7 +++++++
 src/display/fbvgaplanes.cpp |   14 ++++++++++----
 src/encfilter.c             |    1 +
 src/graphdev.cpp            |    2 +-
 src/graphdev.h              |    2 +-
 src/inputmanager.cpp        |    2 +-
 src/inputmanager.h          |    7 ++++---
 src/main.cpp                |    3 ++-
 src/mouse.cpp               |   12 ++++++------
 src/mouse.h                 |   13 ++++---------
 src/zhcon.cpp               |   22 ++++++++++++++--------
 14 files changed, 55 insertions(+), 37 deletions(-)

--- a/configure.in
+++ b/configure.in
@@ -28,7 +28,7 @@
 *-*-linux*)
       echo "Linux detected"
       ZHCON_ARCH="Linux";;
-i?86-*-freebsd*)
+*-*-*freebsd*)
       echo "FreeBsd detected"
       ZHCON_ARCH="FreeBSD"
       dnl gcc 2.95 on freebsd does not search /usr/local/include
--- a/src/console.cpp
+++ b/src/console.cpp
@@ -1089,7 +1089,7 @@
 
 // User settable table: what characters are to be considered alphabetic?
 // 256 bits
-__u32 Console::mInWordLut[8] = {
+uint32_t Console::mInWordLut[8] = {
   0x00000000, // control chars
   0x03FF0000, // digits
   0x87FFFFFE, // uppercase and '_'
--- a/src/console.h
+++ b/src/console.h
@@ -22,6 +22,7 @@
 /**
  *@author ejoy
  */
+#include <stdint.h>
 #include "global.h"
 #include "basefont.h"
 #include "window.h"
@@ -143,7 +144,7 @@
         void SelHighlight(const int begin, const int end);
         void SelPointer(const int offset);
         int  InWord(const unsigned char c);
-        static __u32 mInWordLut[8];
+        static uint32_t mInWordLut[8];
         int  AtColEdge(const int p);
         
         int   mSelStart;  // cleared by clear_selection
--- a/src/display/fbdev.h
+++ b/src/display/fbdev.h
@@ -20,6 +20,13 @@
 #ifndef FBDEV_H
 #define FBDEV_H
 
+#include <stdint.h>
+#ifndef __ASSEMBLY__
+    typedef uint8_t __u8;
+    typedef uint16_t __u16;
+    typedef uint32_t __u32;
+#endif
+
 #include "basefont.h"
 #include "graphdev.h"
 
--- a/src/display/fbvgaplanes.cpp
+++ b/src/display/fbvgaplanes.cpp
@@ -27,7 +27,7 @@
 
 #if defined(linux)
     #include <sys/io.h>
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     #include <machine/sysarch.h>
 static inline void outb(char value, unsigned short port)
 {
@@ -57,7 +57,7 @@
     #define mb()    __asm__ __volatile__ ("lock; addl $0,0(%%esp)": : :"memory")
     #define rmb()   mb()
     #define wmb()   __asm__ __volatile__ ("": : :"memory")
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     #define mb()
     #define rmb()
     #define wmb()
@@ -129,9 +129,12 @@
 #if defined(linux)
     ioperm(GRAPHICS_ADDR_REG, 1, 1);
     ioperm(GRAPHICS_DATA_REG, 1, 1);
-#elif defined(__FreeBSD__)
+#elif (defined(__FreeBSD__) || defined(__FreeBSD_kernel__)) && defined(__i386__)
     i386_set_ioperm(GRAPHICS_ADDR_REG, 1, 1);
     i386_set_ioperm(GRAPHICS_DATA_REG, 1, 1);
+#elif (defined(__FreeBSD__) || defined(__FreeBSD_kernel__)) && defined(__x86_64__)
+    amd64_set_ioperm(GRAPHICS_ADDR_REG, 1, 1);
+    amd64_set_ioperm(GRAPHICS_DATA_REG, 1, 1);
 #endif
     SetDefaultMode();
 }
@@ -140,9 +143,12 @@
 #if defined(linux)
     ioperm(GRAPHICS_ADDR_REG, 1, 0);
     ioperm(GRAPHICS_DATA_REG, 1, 0);
-#elif defined(__FreeBSD__)
+#elif (defined(__FreeBSD__) || defined(__FreeBSD_kernel__)) && defined(__i386__)
     i386_set_ioperm(GRAPHICS_ADDR_REG, 1, 0);
     i386_set_ioperm(GRAPHICS_DATA_REG, 1, 0);
+#elif (defined(__FreeBSD__) || defined(__FreeBSD_kernel__)) && defined(__x86_64__)
+    amd64_set_ioperm(GRAPHICS_ADDR_REG, 1, 0);
+    amd64_set_ioperm(GRAPHICS_DATA_REG, 1, 0);
 #endif
 }
 
--- a/src/encfilter.c
+++ b/src/encfilter.c
@@ -37,6 +37,7 @@
 #include <stdlib.h>
 #include <errno.h>
 #include <assert.h>
+#include <string.h>
 
 #include "encfilter.h"
 
--- a/src/graphdev.cpp
+++ b/src/graphdev.cpp
@@ -30,7 +30,7 @@
 
 #include "display/fbdev.h"
 #include "display/vgadev.h"
-#if defined(linux) || defined(__FreeBSD__)
+#if defined(linux) || defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     #ifdef HAVE_GGI_LIB
     #include "display/libggi.h"
     #endif
--- a/src/graphdev.h
+++ b/src/graphdev.h
@@ -21,7 +21,7 @@
 #define GRPATHDEV_H
 #if defined(linux)
     #include <asm/types.h>
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     #include "utypes.h"
 #endif
 #include <stdexcept>
--- a/src/inputmanager.cpp
+++ b/src/inputmanager.cpp
@@ -667,7 +667,7 @@
     }
 }
 
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
 #include <termios.h>
 //#include <machine/console.h>
 #include <sys/consio.h>
--- a/src/inputmanager.h
+++ b/src/inputmanager.h
@@ -29,10 +29,11 @@
 
 #include <sys/types.h>
 
-#include "mouse.h"
-#if defined(__FreeBSD__)
+#if defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
+    #include <sys/mouse.h>
     #include <sys/kbio.h>
 #endif
+#include "mouse.h"
 
 #define BUFSIZE 8192
 class Zhcon;
@@ -106,7 +107,7 @@
     };
     static KeyMap mKDSysMap[];
     static KeyMap mKDInputMap[];
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     static keymap_t mKDSysOld, mKDSysNew;
     static keymap_t mKDInputOld, mKDInputNew;
 #endif
--- a/src/main.cpp
+++ b/src/main.cpp
@@ -31,9 +31,10 @@
 #include <sys/ioctl.h>
 #if defined(linux)
     #include <linux/kd.h>
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     //#include <machine/console.h>
     #include <sys/consio.h>
+    #include <sys/kbio.h>
 #endif
 #include "zhcon.h"
 #include "global.h"
--- a/src/mouse.cpp
+++ b/src/mouse.cpp
@@ -20,7 +20,7 @@
 #include "mouse.h"
 #include <sys/signal.h>
 
-#if defined(__FreeBSD__)
+#if defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
 Mouse* Mouse::pMouse = NULL;
 void Mouse::SignalProcess(int signo) {
     if (Mouse::pMouse != NULL)  pMouse->Process();
@@ -28,7 +28,7 @@
 #endif
 
 Mouse::Mouse() {
-#if defined(__FreeBSD__)
+#if defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     Mouse::pMouse = this;
 #endif   
     mFd = -1;
@@ -41,7 +41,7 @@
 
 Mouse::~Mouse() {
     Close();
-#if defined(__FreeBSD__)
+#if defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     Mouse::pMouse = NULL;
 #endif
 }
@@ -89,7 +89,7 @@
         event.vc,event.modifiers);
     printf("The button mask is 0x%02X\n",event.buttons);
     */
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     memset(&mMiPrev, 0, sizeof(mMiPrev));
     memset(&mTV1, 0, sizeof(mTV1));
     memset(&mTV2, 0, sizeof(mTV2));
@@ -112,7 +112,7 @@
         return;
     while (Gpm_Close()); // close all mouse stack
     mFd = -1;
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     signal(SIGUSR2, SIG_DFL);
 #endif
 }
@@ -216,7 +216,7 @@
                     return;
             }
     } /* switch above */
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     struct mouse_info mi;
     mi.operation = MOUSE_GETINFO;
     if (ioctl(mConFd, CONS_MOUSECTL, &mi) < 0) {
--- a/src/mouse.h
+++ b/src/mouse.h
@@ -25,13 +25,8 @@
 
 #ifdef HAVE_GPM_H
     #include <gpm.h>
-#elif defined(__FreeBSD__)
-    #if __FreeBSD__ < 5
-        #include <machine/mouse.h>
-    #else
-        #include <sys/mouse.h>
-    #endif
-
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
+    #include <sys/mouse.h>
     #include <sys/consio.h>
     //#include <machine/console.h>
     #include <sys/time.h>
@@ -41,7 +36,7 @@
 
 class Mouse {
     public:
-#if defined(__FreeBSD__)		
+#if defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
 		static void SignalProcess(int signo);
 		static Mouse* pMouse;
 #endif		
@@ -65,7 +60,7 @@
     private:
 #ifdef HAVE_GPM_H
         Gpm_Connect mConn;
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
         struct mouse_info mMiPrev;
         int mClicks;
         struct timeval mTV1;
--- a/src/zhcon.cpp
+++ b/src/zhcon.cpp
@@ -30,14 +30,20 @@
     #include <linux/kd.h>
     #include <linux/vt.h>
     #include <pty.h>
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     #include <termios.h>
     //#include <machine/console.h>
     #include <sys/consio.h>
-    #include <libutil.h>
+    #if defined(__FreeBSD_kernel__)
+        #include <bsd/libutil.h>
+    #else
+        #include <libutil.h>
+    #endif
     #define TCSETA TIOCSETA
 #endif
 
+#include <pty.h>
+
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <fcntl.h>
@@ -317,7 +323,7 @@
     sigaction(SIGFPE, &act, NULL);
 
     VtSignalClean();
-#if defined(__FreeBSD__)
+#if defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     ioctl(0, VT_RELDISP, 1);
 #endif
 
@@ -333,7 +339,7 @@
         // restore console blanking
 #if defined(linux)
         write(mConFd, "\033[9;10]",7);  // default 10 minutes
-#elif defined(__FreeBSD__) 
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
         int BlankTime = 5;  // default 5 minutes
         ioctl(mConFd, CONS_BLANKTIME, &BlankTime);
 #endif
@@ -401,7 +407,7 @@
     t.c_cc[VTIME] = 0;
 #if defined(linux)
     t.c_line = 0;
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     t.c_cc[VDISCARD] = _POSIX_VDISABLE;
     t.c_cc[VLNEXT] = _POSIX_VDISABLE;
     t.c_cc[VSTART] = _POSIX_VDISABLE;
@@ -423,7 +429,7 @@
 #if defined(linux)
     // see kernel's console.c, function setterm_command
     write(mConFd, "\033[9;0]",6);
-#elif defined(__FreeBSD__) 
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     // man splash
     // see /usr/src/sys/dev/syscons/syscons.c
     int BlankTime = 0;
@@ -634,7 +640,7 @@
         //SetEncode(GB2312,GB2312);
         //FreeBsd use zh_CN.EUC instead of zh_CN.GB2312
         //a broken locale? workaround it
-#if defined (__FreeBSD__)
+#if defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
         setenv("LC_CTYPE", "zh_CN.EUC", 1);
 #else
         if (mArgs.utf8_flag)
@@ -686,7 +692,7 @@
     bool r;
 #if defined(linux)
     r = GraphDev::Open(mArgs.drv_arg);
-#elif defined(__FreeBSD__)
+#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)
     int xres = f.GetOption(string("x_resolution"), 640);
     int yres = f.GetOption(string("y_resolution"), 480);
     int depth = f.GetOption(string("color_depth"), 4);
